︠937f4c62-f809-4caf-bc94-7b41af728a3e︠
#  set the number of points to look at.
dimension = 10

# a list of weights to use for blurring our image
filter = [1/4,1/2,1/4]

sum = 0
for term in filter:
    sum += term
if sum != 1:
    print "WARNING: Terms in the filter don't add to 1, there could be trouble!"
    
# These loops create a matrix A of the given dimensions which acts on an input image using our blur filter
A = matrix(QQ,dimension,dimension)
for i in range(0,dimension):
    for j in range(0,len(filter)):
        k = i + j - (len(filter)-1)/2
        if k < 0:
            k = 0
        if k >= dimension:
            k = dimension - 1 
        A[i,k] += filter[j]
︡081de46e-efb4-4736-9244-85e9b0e3d817︡︡
︠25020baf-68b9-428a-8b9e-57cf06f5f259︠
# What does A look like?  This command tells us.  We could also use "print A", but the output is not as pretty.
# What special features do you notice about A?  Why is it like that?

show(A)
︡ba12d88f-4102-4718-ae7a-177cc99bbb30︡︡
︠3c39eb36-616d-4a18-95b5-71ddf6735fbc︠
# In this box, you will find the inverse of A and put it into a matrix Ainv
#    Of course, the command "Ainv = A.inverse()" would do the trick!
#    But let's make life hard for ourselves and do it partly by hand.
#    At the end, you can print your matrix Ainv along with A.inverse() for comparison
#
#    Here are some useful things:
#        identity_matrix(QQ,17)          gives a 17x17 identity matrix
#        X.echelon_form()                gives the reduced row echelon form of X
#        X.augment(Y)                    makes the augmented matrix (X|Y)
#        X.submatrix(i,j,N,M)            extracts a NxM submatrix from X, starting at the (i,j) position
#
# Does the inverse of A have the same special features as A?
︡cccdb521-10e0-4d88-9106-251f14aefb1c︡︡
︠9b4a6d65-8a77-4e70-b03b-2d3980f666fb︠
# ColorStrip defines a function which we will use for visualizing the action of our matrix
# This is horrible code, don't look at it!

def ColorStrip(r, g, b):
    plot = circle((0,0),0)
    for i in range(0,len(r)):
        rr = r[i]
        gg = g[i]
        bb = b[i]
        if rr < 0 or gg < 0 or bb < 0:
            rrr = 0; ggg = 0; bbb = 0;
            if rr < 0:
                rrr -= rr
                rr = 0
            if gg < 0:
                ggg -= gg
                gg = 0
            if bb < 0:
                bbb -= bb      
                bb = 0
            plot += circle((i+0.3,-0.3),0.1,rgbcolor=(rrr, ggg, bbb), fill=True)
        if rr > 1 or gg > 1 or bb > 1:
            rrr = 0; ggg = 0; bbb = 0;
            if rr  > 1:
                rrr += rr - 1
                rr = 1
            if gg > 1:
                ggg += gg - 1
                gg = 1
            if bb > 1:
                bbb += bb - 1     
                bb = 1
            plot += circle((i+0.3,0.3),0.1,rgbcolor=(rrr, ggg, bbb), fill=True)
        plot += circle((i,0),0.4,rgbcolor=(rr, gg, bb), fill=True)
    show(plot, aspect_ratio=1, axes=False)
    return
︡7a068372-db42-4470-a45b-726fb325ca1a︡︡
︠ddad148e-6b2a-4b96-9d76-a61d4e4dccbd︠
# A sample of how to use ColorStrip: the inputs are three lists of equal length, containing the red, green, and blue components of the colors at each point

ColorStrip([1,1,0,0,0,1],[0,1,1,1,0,0],[0,0,0,1,1,1])
︡1f1c27da-3d3d-49a2-95d4-6bc3744a1ba3︡︡
︠0e73488f-8218-4768-8942-d40de836e070︠
# Guess the output of this command before running it.  Then try to modify these commands to produce three circles colored green, yellow, and red.

r = [1/2, 0]
g = [1/2, 0]
b = [1/2, 1/3]

ColorStrip(r, g, b)
︡5a61733b-e923-425b-8b0b-14c33db5faf9︡︡
︠9cc50ca5-e655-4d47-95c6-d956763fdab1︠
# Create an initial color configuration which we will later apply our filter to

red = vector(QQ,dimension)
green = vector(QQ,dimension)
blue = vector(QQ,dimension)

red[3] = 1/2
green[3] = 1
blue[6] = 3/4

ColorStrip(red, green, blue)
︡83f317bb-6d5d-47b3-9a04-16dbb7043a1f︡︡
︠943be73a-d5be-4cb8-b9b5-9d6d29f3b245︠
# Visualize the action of our filter by applying it repeatedly to the initial condition you defined above.

r = red
g = green
b = blue

print "Starting configuration:"
ColorStrip(r,g,b)

print "Applying our filter:"
for i in range(0,10):
    r = A*r
    g = A*g
    b = A*b
    ColorStrip(r,g,b)

print "Applying our inverse filter:"
︡9f238dba-526f-48c2-961a-1149c5f38851︡︡
︠c3ced150-2646-4ce8-8cd1-68e12eb10796︠
# In this entry, experiment with what happens if you apply your inverse filter to the original data to "extra-sharpen" it
︡d096dc06-4c32-4eed-a573-ad957c96596c︡︡
︠44b2873b-2ad5-4f98-b4c3-fabc84ba2548︠
# In this entry, experiment with what happens if you
#     1) apply the filter to the initial data
#     2) make a small change or changes to the result
#     3) apply your inverse filter.  
#
# Is your filter well-conditioned, ill-conditioned, or somewhere in between?
︡84431884-f7b2-427b-9d72-0cc747527ec2︡︡
